//Mit diesem Code klappt es jetzt, dass alle Motoren gleichzeitig angesteuert werden.
#include <Servo.h>
const int stepPinRechts = 3;  //Pins für die Räder.
const int dirPinRechts = 2;
const int stepPinLinks = 5;
const int dirPinLinks = 4;
Servo gelenk;//Servo der den Greifarm hoch-/runterfährt.
Servo greifer;//Greifmechanismus.
int stifte = 0;        //Variablen um die Anzahl der sich im Trichter befindenden Stifte/ die Position des Greifarms zu speichern.
int greifarmpos = 10;
int greifarmpos2 = 0;
int greiferstatus = 90;

void setup() {
  //Sets the two pins as Outputs
  pinMode(stepPinRechts, OUTPUT);
  pinMode(dirPinRechts, OUTPUT);
  pinMode(stepPinLinks, OUTPUT);
  pinMode(dirPinLinks, OUTPUT);
  pinMode(8, OUTPUT); //Step-Pin, Servo Greifarm.
  pinMode(9, OUTPUT); //Direction-Pin, Servo Greifarm.
  pinMode(A3, INPUT); //Infrarotsensor Kante.
  pinMode(A2, INPUT); //Infrarotsensor Stifte.
  gelenk.attach(10);
  greifer.attach(11);
  gelenk.write(10);
  greifer.write(90);
  delay(1000);
}


void dir1 (void) {
  digitalWrite(dirPinRechts, HIGH);
  digitalWrite(dirPinLinks, LOW);
}

void dir2 (void) {
  digitalWrite(dirPinRechts, LOW);
  digitalWrite(dirPinLinks, HIGH);
}

void turn90R (int geschwindigkeit) {
  digitalWrite(dirPinRechts, LOW);
  digitalWrite(dirPinLinks, LOW);
  for (int x = 0; x < 132; x++) fahren(geschwindigkeit);
  dir2();


}

void turn90L (int geschwindigkeit) {
  digitalWrite(dirPinRechts, HIGH);
  digitalWrite(dirPinLinks, HIGH);
  for (int x = 0; x < 131; x++) fahren(geschwindigkeit);
  dir2 ();
}



void beschleunigen () { //Wird noch angepasst.
  int c = 7500;
  for (int i = 0; i < 250; i++) {

    fahren(c);
    c -= 10;

  }
}

void fahren (int geschwindigkeit) {
  if (analogRead(A2) < 430 & greifarmpos == 10) {  //Kein Stift im Trichter.
    //gelenk.detach();
    //greifer.detach();
    stifte = 0;
  }
  if (analogRead(A2) > 430 & greifarmpos == 10) { // 1 Stift im Trichter
    stifte = 1;
    //gelenk.attach(A6);
    //greifer.attach(A7);
  }
  if (analogRead(A2) > 430 & greifarmpos >= 70) {  //1 Stift im Trichter, während der Greifarm noch am arbeiten ist.
    stifte = 2;
  }
  switch (stifte) {
    case (0):   //befindet sich kein Stift im Trichter bewegt sich der Roboter einfach vorwärts.
      digitalWrite(stepPinRechts, HIGH);
      digitalWrite(stepPinLinks, HIGH);
      delayMicroseconds(geschwindigkeit);
      digitalWrite(stepPinRechts, LOW);
      digitalWrite(stepPinLinks, LOW);
      delayMicroseconds(geschwindigkeit);
      break;


    case (1): //Befindet sich ein Stift im Trichter, bewegt sich der Roboter weiter vorwärts. Gleichzeitig beginnt auch der Greifarm mit dem Transportprozess.
      if (greifarmpos == 10 & greiferstatus == 90) {   //Abhängig davon in welcher Phase sich der Greifarm befindet, werden immer die Räder und ein Motor im Greifarm angesteuert.
        greiferstatus = 150;
        greifer.write(150);
        for (int i = 0; i < 60; i++) {
          digitalWrite(stepPinRechts, HIGH);
          digitalWrite(stepPinLinks, HIGH);
          delayMicroseconds(geschwindigkeit);
          digitalWrite(stepPinRechts, LOW);
          digitalWrite(stepPinLinks, LOW);
          delayMicroseconds(geschwindigkeit);
        }

      }
      if (greifarmpos < 90 & greiferstatus == 150) {
        greifarmpos += 1;
        gelenk.write(greifarmpos);
        for (int i = 0 ; i < 3 ; i++) {
          digitalWrite(stepPinRechts, HIGH);
          digitalWrite(stepPinLinks, HIGH);
          delayMicroseconds(geschwindigkeit);
          digitalWrite(stepPinRechts, LOW);
          digitalWrite(stepPinLinks, LOW);
          delayMicroseconds(geschwindigkeit);
        }
      }
      if (greifarmpos == 90 & greiferstatus == 150 & greifarmpos2 < 100) {
        greifarmpos2 += 1;
        digitalWrite(9, LOW);
        digitalWrite(8, HIGH);
        digitalWrite(stepPinRechts, HIGH);
        digitalWrite(stepPinLinks, HIGH);
        delayMicroseconds(geschwindigkeit);
        digitalWrite(8, LOW);
        digitalWrite(stepPinRechts, LOW);
        digitalWrite(stepPinLinks, LOW);
        delayMicroseconds(geschwindigkeit);
      }
      if (greifarmpos == 90 & greiferstatus == 150 & greifarmpos2 == 100) {
        greiferstatus = 90;
        greifer.write(90);
        for (int i = 0; i < 60; i++) {
          digitalWrite(stepPinRechts, HIGH);
          digitalWrite(stepPinLinks, HIGH);
          delayMicroseconds(geschwindigkeit);
          digitalWrite(stepPinRechts, LOW);
          digitalWrite(stepPinLinks, LOW);
          delayMicroseconds(geschwindigkeit);
        }
      }
      if (greifarmpos == 90 & greiferstatus == 90 & greifarmpos2 > 0) {
        greifarmpos2 -= 1;
        digitalWrite(9, HIGH);
        digitalWrite(8, HIGH);
        digitalWrite(stepPinRechts, HIGH);
        digitalWrite(stepPinLinks, HIGH);
        delayMicroseconds(geschwindigkeit);
        digitalWrite(8, LOW);
        digitalWrite(stepPinRechts, LOW);
        digitalWrite(stepPinLinks, LOW);
        delayMicroseconds(geschwindigkeit);
      }
      if (greifarmpos > 10 & greiferstatus == 90 & greifarmpos2 == 0) {
        greifarmpos -= 1;
        gelenk.write(greifarmpos);
        for (int i = 0 ; i < 3 ; i++) {
          digitalWrite(stepPinRechts, HIGH);
          digitalWrite(stepPinLinks, HIGH);
          delayMicroseconds(geschwindigkeit);
          digitalWrite(stepPinRechts, LOW);
          digitalWrite(stepPinLinks, LOW);
          delayMicroseconds(geschwindigkeit);
        }
      }

      break;
    case (2): //Kommt noch...In diesem Fall stoppt der Roboter die Fahrt, damit es zu keinem "Stifte-Stau" kommt.
      break;

  }




}




void loop() {
  
  dir2 ();
  beschleunigen();

  while (analogRead(A3) > 100) {

    fahren(6000);


  }
  delay(1000);

  turn90R(6500);

  delay(1000);


  for (int i = 0; i < 639; i++) fahren(6500);

  delay(1000);

  turn90R(6500);

  delay(1000);

  beschleunigen();
  while (analogRead(A3) > 100) {
    fahren(6000);
  }

  delay(1000);

  turn90L(6500);

  delay(1000);

  for (int i = 0; i < 639; i++) fahren(6500);

  delay(1000);

  turn90L(6500);










  
}





